diff --git a/calendar/lib.php b/calendar/lib.php
index dcedc54..4522f09 100644
--- a/calendar/lib.php
+++ b/calendar/lib.php
@@ -3102,14 +3102,20 @@ function calendar_import_icalendar_events($ical, $courseid, $subscriptionid = nu
  * @return string A log of the import progress, including errors.
  */
 function calendar_update_subscription_events($subscriptionid) {
-    global $DB;
+    global $DB, $CFG;
+	
+    require_once($CFG->dirroot.'/local/lsf_unification/cal_lib.php');
 
     $sub = calendar_get_subscription($subscriptionid);
     // Don't update a file subscription. TODO: Update from a new uploaded file.
     if (empty($sub->url)) {
         return 'File subscription not updated.';
     }
-    $ical = calendar_get_icalendar($sub->url);
+    if ($sub->url == HIS_CAL_IDENTIFIER) {
+        $ical = calendar_get_icalendar(his_get_ical_url($sub->userid));
+    } else {
+        $ical = calendar_get_icalendar($sub->url);
+    }
     $return = calendar_import_icalendar_events($ical, $sub->courseid, $subscriptionid);
     $sub->lastupdated = time();
     calendar_update_subscription($sub);
diff --git a/calendar/managesubscriptions_form.php b/calendar/managesubscriptions_form.php
index 769a5b5..98724d2 100644
--- a/calendar/managesubscriptions_form.php
+++ b/calendar/managesubscriptions_form.php
@@ -27,6 +27,7 @@ if (!defined('MOODLE_INTERNAL')) {
 }
 
 require_once($CFG->libdir.'/formslib.php');
+require_once($CFG->dirroot.'/local/lsf_unification/cal_lib.php');
 
 /**
  * Form for adding a subscription to a Moodle course calendar.
@@ -42,6 +43,8 @@ class calendar_addsubscription_form extends moodleform {
         $mform = $this->_form;
         $courseid = optional_param('course', 0, PARAM_INT);
 
+        his_print_cal_import_form($mform);
+        
         $mform->addElement('header', 'addsubscriptionform', get_string('importcalendarheading', 'calendar'));
 
         // Name.
